blob: da789642bd96478a94869908592214a35e4cd958 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
Petr Michalecb3120042018-03-17 11:17:32 +01009# NOTE: This script is collection of shared functions to automate bootstrap of "salted" CI environments.
10# Its not intended to be used in PRODUCTION unless you know what you are doing.
11# You have been warned!
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020012
13# Source specific env vars.
14# shopt -u dotglob
15export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
16function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020017 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030018 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
19 echo "Sourcing env variables from $f"
20 source $f
21 done
22 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020023}
24source_local_envs
25
26##########################################
27# Set defaults env variables
28
29if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
30 set -x
31 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
32fi
33
34export MAGENTA='\033[0;95m'
35export YELLOW='\033[1;33m'
36export BLUE='\033[0;35m'
37export CYAN='\033[0;96m'
38export RED='\033[0;31m'
39export NC='\033[0m' # No Color'
40
41export LC_ALL=C
42export SALT_LOG_LEVEL="--state-verbose=false -lerror"
43export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
44export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020045
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020046# salt apt repository
47test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
48which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
49#
Dmitry Ukov95492a02017-10-23 11:34:45 +040050export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt}
chnyda30c07a62017-09-20 14:28:02 +020051export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020052# reclass
53export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
ibumarskovf72e05e2017-11-29 14:37:48 +030054export RECLASS_BRANCH=${RECLASS_BRANCH:-master}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020055
56# formula
57export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
58export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
59export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
60export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
Petr Michalec515356f2017-11-16 11:20:20 +010061# Essential set of formulas (known to by used on cfg01 node for most setups during bootsrap)
62# DEPRECATED: FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS maas memcached ntp nginx collectd sensu heka sphinx mysql grafana libvirt rsyslog glusterfs postfix xtrabackup freeipa prometheus telegraf elasticsearch kibana rundeck devops-portal rsync docker keepalived aptly jenkins gerrit artifactory influxdb horizon}
Petr Michalece07cd0b2017-11-15 11:41:57 +010063FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020064# minimal set of formulas for salt-master bootstrap
Petr Michalec515356f2017-11-16 11:20:20 +010065declare -a FORMULAS_SALT_MASTER=(reclass salt git openssh linux $(echo $FORMULAS_SALT_MASTER))
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020066export FORMULAS_SALT_MASTER
67
68# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020069export HOSTNAME=${HOSTNAME:-`hostname -s`}
70export HOSTNAME=${HOSTNAME//.*/}
71export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020072export DOMAIN=${DOMAIN:-bootstrap.local}
73
74# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020075export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020076export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020077
78# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020079BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
alexz0adc2712018-02-11 17:33:52 +010080BOOTSTRAP_SALTSTACK_COM=${BOOTSTRAP_SALTSTACK_COM:-"https://bootstrap.saltstack.com"}
Martin Polreich16673dd2018-04-20 12:08:56 +020081BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2017.7 }
Jakub Josef0b611742018-01-09 17:02:01 +010082BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION//latest*/stable}
alexz0adc2712018-02-11 17:33:52 +010083# TODO add 'r' option by default
84# Currently, without 'r' option, upstream saltstack repos will be used. Otherwise
85# local one should be used, from http://apt.mirantis.com/ or whatever.
Petr Michalec33c04892017-09-08 15:10:30 +020086BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020087SALT_SOURCE=${SALT_SOURCE:-pkg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020088
Petr Michalecb3120042018-03-17 11:17:32 +010089# SECURITY
Petr Michalecca2471f2018-03-17 11:17:32 +010090SSH_STRICTHOSTKEYCHECKING=no
Petr Michalecb3120042018-03-17 11:17:32 +010091
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020092# environment
93if [ "$FORMULAS_SOURCE" == "git" ]; then
94 SALT_ENV=${SALT_ENV:-dev}
95elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
96 SALT_ENV=${SALT_ENV:-prd}
97fi
Petr Michalec05b52452017-09-08 14:26:59 +020098eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020099PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
100case $PLATFORM_FAMILY in
101 debian )
102 PKGTOOL="$SUDO apt-get"
103 test ${VERSION_ID//\.*/} -ge 16 && {
104 SVCTOOL=service
105 } || { SVCTOOL=service
106 }
107 ;;
108 rhel )
109 PKGTOOL="$SUDO yum"
110 test ${VERSION_ID//\.*/} -ge 7 && {
111 SVCTOOL=systemctl
112 } || { SVCTOOL=service
113 }
114 ;;
115esac
116
117export PLATFORM_FAMILY
118export PKGTOOL
119export SVCTOOL
120
121##########################################
122# FUNCTIONS
123
124log_info() {
125 echo -e "${YELLOW}[INFO] $* ${NC}"
126}
127
128log_warn() {
129 echo -e "${MAGENTA}[WARN] $* ${NC}"
130}
131
Petr Michalec24b30e82017-08-21 10:59:18 +0200132log_debug() {
133 echo -e "${CYAN}[WARN] $* ${NC}"
134}
135
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200136log_err() {
137 echo -e "${RED}[ERROR] $* ${NC}" >&2
138}
139
140configure_pkg_repo()
141{
142
143 case $PLATFORM_FAMILY in
144 debian)
145 if [ -n "$APT_REPOSITORY_PPA" ]; then
146 which add-apt-repository || $SUDO apt-get install -y software-properties-common
147 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
148 else
Mykyta Karpinfbcb5482017-10-04 14:15:25 +0300149 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200150 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
151 fi
152 $SUDO apt-get clean
153 $SUDO apt-get update
154 ;;
155 rhel)
156 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
157 $SUDO yum clean all
158 ;;
159 esac
160
161}
162
163_atexit() {
164 RETVAL=$?
165 trap true INT TERM EXIT
166
167 if [ $RETVAL -ne 0 ]; then
168 log_err "Execution failed"
169 else
170 log_info "Execution successful"
171 fi
172 return $RETVAL
173}
174
175retry() {
176 local tries
177 if [[ $1 =~ ^[0-9]+$ ]]; then
178 tries=$1; shift
179 else
180 tries=3
181 fi
Petr Michalec262e3ad2017-10-06 13:41:58 +0200182 ret=1
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200183 for i in $(seq 1 $tries); do
Petr Michalec262e3ad2017-10-06 13:41:58 +0200184 "$@" && return $? || ret=$?
185 sleep $i
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200186 done
Petr Michalec9fec8b32017-10-05 14:46:42 +0200187 return $ret
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200188}
189
190function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200191 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200192 # No reclass at all, clone from given address
alexz0adc2712018-02-11 17:33:52 +0100193 # In case, non-github repo
194 _tmp_host=$(echo ${RECLASS_ADDRESS} | awk -F/ '{print $3}')
195 ssh-keyscan -T 1 -H ${_tmp_host} >> ~/.ssh/known_hosts || true
196 # But, awk is not perfect solution, so lets make double-check for github
197 ssh-keyscan -T 1 -H github.com >> ~/.ssh/known_hosts || true
ibumarskovf72e05e2017-11-29 14:37:48 +0300198 if echo ${RECLASS_BRANCH} | egrep -q "^refs"; then
199 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
200 cd ${RECLASS_ROOT}
201 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH} && git checkout FETCH_HEAD
202 export RECLASS_REVISION=$(git rev-parse HEAD)
203 cd -
204 else
205 git clone -b ${RECLASS_BRANCH} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200206 fi;
207 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200208 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200209 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
210 ls -Rla ${RECLASS_ROOT}
211 exit 1
212 fi;
213 $SUDO mkdir -p $RECLASS_ROOT/classes/service
214 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200215}
216
217
218##########################################
219# Main calls
220
Petr Michalecca2471f2018-03-17 11:17:32 +0100221ci_config_ssh() {
222
223 # for CI current user
Petr Michalecb3120042018-03-17 11:17:32 +0100224 conf=~/.ssh/config
225 mkdir -p $(dirname $conf)
226 touch $conf
Petr Michalecca2471f2018-03-17 11:17:32 +0100227 echo -e "Host *\n\tStrictHostKeyChecking $SSH_STRICTHOSTKEYCHECKING\n" | tee -a $conf >/dev/null
Petr Michalecb3120042018-03-17 11:17:32 +0100228 touch ~/.ssh/known_hosts
Petr Michalecca2471f2018-03-17 11:17:32 +0100229
Petr Michalecda014202017-08-18 11:26:07 +0200230 if ! grep github.com ~/.ssh/known_hosts; then
231 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
Petr Michalecb3120042018-03-17 11:17:32 +0100232 ssh-keyscan -H gitlab.com >> ~/.ssh/known_hosts || true
Petr Michalecda014202017-08-18 11:26:07 +0200233 fi
Petr Michalecb3120042018-03-17 11:17:32 +0100234
235 # for root
236 #conf=/root/.ssh/config
237 #$SUDO mkdir -p $(dirname $conf)
238 #$SUDO touch $conf
239 #if ! $SSH_STRICTHOSTKEYCHECKING; then
240 # echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee -a $conf >/dev/null
241 #fi
Petr Michalecda014202017-08-18 11:26:07 +0200242}
243
Petr Michalecca2471f2018-03-17 11:17:32 +0100244# DEPRECATED
245system_config_ssh_conf() {
246 # for backward compatibility
247 ci_config_ssh
Petr Michalecda014202017-08-18 11:26:07 +0200248}
249
250system_config_salt_modules_prereq() {
251 # salt-formulas custom modules dependencies, etc:
Petr Ruzickade2cd3b2017-12-07 14:41:20 +0100252 $SUDO $PKGTOOL install -y apt-transport-https curl git iproute2 openssh-client python-psutil python-apt python-m2crypto python-oauth python-pip sudo &>/dev/null
Petr Michalecda014202017-08-18 11:26:07 +0200253}
254
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200255system_config_minion() {
256 log_info "System configuration salt minion"
257}
258
259system_config_master() {
260 log_info "System configuration salt master"
261
Petr Michalecda014202017-08-18 11:26:07 +0200262 system_config_salt_modules_prereq
Petr Michalecca2471f2018-03-17 11:17:32 +0100263 ci_config_ssh
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200264
Petr Michalecda014202017-08-18 11:26:07 +0200265 if ! grep '127.0.1.2.*salt' /etc/hosts; then
266 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
267 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200268}
269
270configure_salt_master()
271{
272
273 echo "Configuring salt-master ..."
274
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200275 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec29d3ea32017-10-31 17:22:36 +0100276 read -d '' IGNORE_CLASS_NOTFOUND <<-EOF
277 ignore_class_notfound: True
278 ignore_class_regexp:
279 - 'service.*'
280EOF
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200281 fi
282
Petr Michalecdd1a0472017-09-06 19:27:24 +0200283 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200284 if [ -n "$RECLASS_SOURCE_PATH" ]; then
285 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
286 else
287 RECLASS_SOURCE_PATH=""
288 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200289
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200290 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
291 cat <<-EOF > /etc/salt/master.d/master.conf
292 file_roots:
293 base:
294 - /usr/share/salt-formulas/env
295 prd:
296 - /srv/salt/env/prd
297 dev:
298 - /srv/salt/env/dev
299 pillar_opts: False
300 open_mode: True
301 reclass: &reclass
302 storage_type: yaml_fs
303 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200304 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200305 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200306 ext_pillar:
307 - reclass: *reclass
308 master_tops:
309 reclass: *reclass
310EOF
311
312 echo "Configuring reclass ..."
313
314 [ ! -d /etc/reclass ] && mkdir /etc/reclass
315 cat <<-EOF > /etc/reclass/reclass-config.yml
316 storage_type: yaml_fs
317 pretty_print: True
318 output: yaml
319 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200320EOF
321
322 clone_reclass
323 # override some envs from cluster level *.env, use with care
324 source_local_envs
325
326 cd ${RECLASS_ROOT}
327 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
328 # Possibly subrepo checkout needed
329 git submodule update --init --recursive
330 fi
331
Petr Michalec212cc6a2017-08-17 21:39:40 +0200332 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200333 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
334
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200335 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200336 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200337 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200338 log_warn "Salt Master node specification has not been found in model."
339 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200340 cat <<-EOF > ${CONFIG}
341 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200342 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200343 parameters:
344 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200345 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200346 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200347 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
ibumarskovf72e05e2017-11-29 14:37:48 +0300348 reclass_data_revision: ${RECLASS_REVISION:-$RECLASS_BRANCH}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200349 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200350 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200351 linux_system_codename: ${DISTRIB_CODENAME}
352 cluster_name: ${CLUSTER_NAME}
353 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200354 linux:
355 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200356 name: ${HOSTNAME:-cfg01}
357 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200358 # ########
359EOF
360
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200361 cat <<-EOF >> ${CONFIG}
362 salt:
363 master:
364 accept_policy: open_mode
365 source:
366 engine: $SALT_SOURCE
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200367 minion:
368 source:
369 engine: $SALT_SOURCE
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200370 # ########
371 # vim: ft=yaml sw=2 ts=2 sts=2
372EOF
373 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200374
375 log_debug "Salt Master node config yaml:"
376 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200377}
378
379configure_salt_minion()
380{
381 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
382 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200383 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200384 id: $MINION_ID
385 EOF
386}
387
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200388install_reclass()
389{
390 VERSION=${1:-$RECLASS_VERSION}
Petr Michalec372fa032017-11-15 17:36:19 +0100391 VERSION=${VERSION:-pkg}
Petr Michalec800dd072017-11-15 17:19:26 +0100392 case ${VERSION} in
393 pkg|package)
394 which reclass || $SUDO $PKGTOOL install -y reclass
rootb9e5d7c2018-03-17 12:12:44 +0000395 which reclass-salt || {
396 if [ -e /usr/share/reclass/reclass-salt ]; then
Petr Michalec6ba1c362018-03-17 15:01:51 +0100397 ln -fs /usr/share/reclass/reclass-salt /usr/bin
rootb9e5d7c2018-03-17 12:12:44 +0000398 fi
399 }
Petr Michalec800dd072017-11-15 17:19:26 +0100400 ;;
401 *)
Petr Michalec981f3cc2017-11-15 17:40:31 +0100402 log_warn "Install development version of reclass"
Petr Michalec1b37d3d2017-11-15 18:20:46 +0100403 # Note: dev/git/pip version...
404 # It replaces all local reclass versions on system
405 # Required for reclass/git features:
406 # $SUDO $PKGTOOL install -y libffi-dev libgit2-dev || true
Petr Michalec800dd072017-11-15 17:19:26 +0100407 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michalec23020832017-11-15 17:34:49 +0100408 sudo -H pip install --install-option="--prefix=" --upgrade --force-reinstall -I \
Petr Michalec800dd072017-11-15 17:19:26 +0100409 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
410 done
411 ;;
412 esac
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200413}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200414
415install_salt_master_pkg()
416{
417 echo -e "\nPreparing base OS repository ...\n"
418
419 configure_pkg_repo
420
421 echo -e "\nInstalling salt master ...\n"
422
423 case $PLATFORM_FAMILY in
424 debian)
425 $SUDO apt-get install -y git
alexz0adc2712018-02-11 17:33:52 +0100426 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200427 ;;
428 rhel)
429 yum install -y git
alexz0adc2712018-02-11 17:33:52 +0100430 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200431 ;;
432 esac
Jakub Josef0b611742018-01-09 17:02:01 +0100433
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200434 configure_salt_master
435
436 echo -e "\nRestarting services ...\n"
437 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
438 $SVCTOOL salt-master restart
439}
440
441install_salt_master_pip()
442{
443 echo -e "\nPreparing base OS repository ...\n"
444
445 case $PLATFORM_FAMILY in
446 debian)
447 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200448 ;;
449 rhel)
450 $SUDO yum install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200451 ;;
452 esac
453
454 echo -e "\nInstalling salt master ...\n"
455 # TODO: replace with saltstack bootstrap script
Jakub Josef0b611742018-01-09 17:02:01 +0100456
Petr Michalec88a95a22018-01-09 17:21:08 +0100457 if [ -z ${PIP_SALT_VERSION} ] || [ "$PIP_SALT_VERSION" == "latest" ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200458 pip install salt
459 else
Petr Michalec88a95a22018-01-09 17:21:08 +0100460 pip install salt==${PIP_SALT_VERSION}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200461 fi
462
463 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
464 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
465
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200466 configure_salt_master
467
468 echo -e "\nRestarting services ...\n"
469 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
470 $SVCTOOL salt-master restart
471}
472
473
474
475install_salt_minion_pkg()
476{
477
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200478 echo -e "\nInstalling salt minion ...\n"
479
480 case $PLATFORM_FAMILY in
481 debian)
alexz0adc2712018-02-11 17:33:52 +0100482 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200483 ;;
484 rhel)
alexz0adc2712018-02-11 17:33:52 +0100485 curl -L ${BOOTSTRAP_SALTSTACK_COM} | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200486 ;;
487 esac
488
489
490 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200491 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200492}
493
494install_salt_minion_pip()
495{
496 echo -e "\nInstalling salt minion ...\n"
497
498 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
499 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
500
501 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200502 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200503}
504
505
506install_salt_formula_pkg()
507{
508 configure_pkg_repo
509
510 case $PLATFORM_FAMILY in
511 debian)
512 echo "Configuring necessary formulas ..."
513
514 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
515 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100516 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200517 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
518 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
519 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
520 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
521 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
522 exit 1
523 fi
Oleksii Grudev691d4712018-04-02 10:23:46 +0300524 #Since some salt formula names contain "-" and in symlinks they should contain "_" adding replacement
525 formula_service=${formula_service//-/$'_'}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200526 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
527 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
528 done
529 ;;
530 rhel)
531 # TODO
532 ;;
533 esac
534
535 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
536 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
537}
538
539install_salt_formula_git()
540{
541 echo "Configuring necessary formulas ..."
542
543 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
544 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
Petr Michalec2d753972017-11-30 16:24:37 +0100545 [ -z ${FORMULAS_SALT_MASTER} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200546 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
547 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
548 _BRANCH=${FORMULAS_BRANCH}
549 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
550 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
551 # Fallback to the master branch if the branch doesn't exist for this repository
552 _BRANCH=master
553 fi
554 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
555 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
556 exit 1
557 fi
558 } || {
559 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
560 git fetch origin/${_BRANCH} || git fetch --all
561 git checkout ${_BRANCH} && git pull || git pull;
562 cd -
563 }
564 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
565 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
566 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
567 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
568 done
569
570 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
571 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
572}
573
Petr Michalece9c84522017-12-13 17:14:08 +0100574saltservice_stop() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100575 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100576 $SUDO service salt-minion stop
577 $SUDO service salt-master stop
578 sleep ${SALT_STOPSTART_WAIT:-30}
Petr Michalec7822efe2017-12-15 16:19:32 +0100579 ${SUDO} pkill -9 salt-master && ${SUDO} rm -rf /var/run/salt/master/* || true
Petr Michalece9c84522017-12-13 17:14:08 +0100580 ${SUDO} pkill -9 salt-minion
581}
582saltservice_start() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100583 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100584 $SUDO service salt-master start
585 $SUDO service salt-minion start
586 sleep ${SALT_STOPSTART_WAIT:-30}
587}
588
589saltservice_restart() {
Petr Michalecdd646db2017-12-18 15:56:18 +0100590 set +e
Petr Michalece9c84522017-12-13 17:14:08 +0100591 saltservice_stop
592 saltservice_start
593}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200594
595saltmaster_bootstrap() {
596
597 log_info "Salt master setup"
598 test -n "$MASTER_HOSTNAME" || exit 1
599
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200600 # override some envs from cluster level *.env, use with care
601 source_local_envs
602
Petr Michalece9c84522017-12-13 17:14:08 +0100603 saltservice_stop
604
605 clone_reclass
606
projoke3c30e7d2017-10-19 17:15:40 +0800607 SCRIPTS=$(dirname $0)
Petr Michalece9c84522017-12-13 17:14:08 +0100608
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200609 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200610 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200611 export MINION_ID=${MASTER_HOSTNAME}
612 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
613 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
614 fi
615 # call local "setup() master"
616 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
617 if ! setup master; then
618 #cat /tmp/salt-master-setup.log
619 log_err "salt master setup() failed."
620 exit 1
621 else
622 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
623 fi
624 }
625
Petr Michalec981f3cc2017-11-15 17:40:31 +0100626 log_info "Install reclass"
627 install_reclass ${RECLASS_VERSION/dev*/develop}
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200628
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200629 log_info "Re/starting salt services"
Petr Michalece9c84522017-12-13 17:14:08 +0100630 saltservice_restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200631}
632
633# Init salt master
634saltmaster_init() {
635
636 log_info "Runing saltmaster states"
637 test -n "$MASTER_HOSTNAME" || exit 1
638
639 set -e
640 $SUDO salt-call saltutil.sync_all >/dev/null
641
Petr Michalecda014202017-08-18 11:26:07 +0200642 # workarond isolated and not fully bootstraped environments
Petr Michalec2801acb2017-10-31 15:00:15 +0100643 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec54ee4082017-11-30 17:02:17 +0100644 SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": '${RECLASS_IGNORE_CLASS_NOTFOUND:-False}', "ignore_class_regexp": ["service.*"]}}}},'
Petr Michalec2801acb2017-10-31 15:00:15 +0100645 fi
Petr Michalec8ce8a652017-11-30 15:39:20 +0100646 PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200647
Petr Michalec8b92d552017-11-29 12:28:50 +0100648 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100649 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100650 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200651 fi
652
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200653 # Revert temporary SaltMaster minimal configuration, if any
654 pushd $RECLASS_ROOT
655 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
Petr Michalec87778fc2017-11-02 10:13:25 +0100656 PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200657 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200658 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200659 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
660 git checkout -- $RECLASS_ROOT/nodes || true
661 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
Petr Michalec7edf8322017-11-30 12:01:09 +0100662 log_info "State: salt.master.env,salt.master.pillar"
Petr Michalec54ee4082017-11-30 17:02:17 +0100663 if ! $SUDO salt-call ${SALT_OPTS} state.apply salt.master.env,salt.master.pillar pillar="$PILLAR"; then
Petr Michalec85ef7ad2017-11-30 15:21:19 +0100664 log_err "State \`salt.master.env,salt.master.pillar pillar=$PILLAR\` failed, keep your eyes wide open!"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200665 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200666 fi
667 popd
668
Petr Michalecda014202017-08-18 11:26:07 +0200669 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
670 log_info "State: salt.master.service"
Jakub Josef32563412018-01-17 17:55:05 +0100671 # ensure salt master is started
672 saltservice_start
Petr Michalec9fec8b32017-10-05 14:46:42 +0200673 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalec4f043772017-12-19 15:40:54 +0100674 saltservice_start
Petr Michalecda014202017-08-18 11:26:07 +0200675
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200676 log_info "State: salt.master.storage.node"
677 set +e
Petr Michalec7edf8322017-11-30 12:01:09 +0100678 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
679 # FIXME: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec9fec8b32017-10-05 14:46:42 +0200680 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200681 ret=$?
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200682
Petr Michalecdd646db2017-12-18 15:56:18 +0100683 set -e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200684 if [[ $ret -eq 2 ]]; then
685 log_err "State reclass.storage.node failed with exit code 2 but continuing."
686 elif [[ $ret -ne 0 ]]; then
687 log_err "State reclass.storage.node failed with exit code $ret"
688 exit 1
689 fi
690
Petr Michalecdd646db2017-12-18 15:56:18 +0100691 set +e
692 log_info "Updating minion.conf -> master: localhost"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200693 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecdd646db2017-12-18 15:56:18 +0100694
695 log_info "Re/starting salt services" # in order to load new deployed configuration from model
Petr Michalece9c84522017-12-13 17:14:08 +0100696 saltservice_restart
Petr Michalecdd646db2017-12-18 15:56:18 +0100697
698 log_info "Salt Util sync all"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200699 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
700
701 verify_salt_master
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200702
703}
704
Petr Michalec71e32682018-03-22 08:34:34 +0100705## CI Workarounds
706
707function mockup_node_registration() {
708
709 # for dynamic nodes registrations (require github.com/salt-formulas/salt-formula-reclass)
710
711 source /etc/os-release
712 os_codename=$VERSION_CODENAME
713 domain=$(hostname -d)
714 master_ip=$(hostname -I | awk '{print $1}')
715 fake_ip_preffix=$(echo $master_ip | awk -F. '{print $1"."$2}')
716 fake_ip_base=10
717
718 # SHOULD BE ALREADY RUN AS A PART OF BOOTSTRAP
719 # sync, in order to load custom modules
720 #salt-call saltutil.sync_all
721
722 # SHOULD BE ALREADY RUN AS A PART OF BOOTSTRAP
723 #PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
724 #salt-call state.apply reclass.storage.node pillar="$PILLAR" > /dev/null 2>/dev/null || true
725
726 # rotate over dynamic hosts
727 for host_idx in {01..02};do
728 for host in `salt-call pillar.items reclass:storage |grep '<<node_hostname>>' | awk -F_ '{print $NF}' | sed 's/[0-9]*//g' | egrep -v cfg | sort -u`; do
729 hostname=${host}${host_idx}
730 fake_ip_base=$(($fake_ip_base + 1))
731
732 node_network01_ip="$fake_ip_preffix.11.$fake_ip_base"
733 node_network02_ip="$fake_ip_preffix.12.$fake_ip_base"
734 node_network03_ip="$fake_ip_preffix.13.$fake_ip_base"
735 node_network04_ip="$fake_ip_preffix.14.$fake_ip_base"
736 node_network05_ip="$fake_ip_preffix.15.$fake_ip_base"
737 node_network01_iface=$(ls /sys/class/net/ | grep -v lo | sort | head -n1)
738 node_network02_iface="eth1"
739 node_network03_iface="eth2"
740 node_network04_iface="eth3"
741 node_network05_iface="eth4"
742
743 declare -A vars
744 vars=(
745 ["node_master_ip"]=
746 ["node_os"]=${os_codename}
747 ["node_deploy_ip"]=${node_network01_ip}
748 ["node_deploy_iface"]=${node_network01_iface}
749 ["node_control_ip"]=${node_network02_ip}
750 ["node_control_iface"]=${node_network02_iface}
751 ["node_tenant_ip"]=${node_network03_ip}
752 ["node_tenant_iface"]=${node_network03_iface}
753 ["node_external_ip"]=${node_network04_ip}
754 ["node_external_iface"]=${node_network04_iface}
755 ["node_baremetal_ip"]=${node_network05_ip}
756 ["node_baremetal_iface"]=${node_network05_iface}
757 ["node_domain"]=$domain
758 ["node_cluster"]=$(hostname -d |awk -F. '{print $1}')
759 ["node_hostname"]=$hostname
760 )
761
762 data=""; i=0
763 for key in "${!vars[@]}"; do
764 data+="\"${key}\": \"${vars[${key}]}\""
765 i=$(($i+1))
766 if [ $i -lt ${#vars[@]} ]; then
767 data+=", "
768 fi
769 done
770 echo "Classifying node $hostname"
771 NODECR='"node_name": "'${hostname}.${domain}'", "node_data": {'$data'}'
772 PILLAR='{'${NODECR}', "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
773 salt-call state.apply reclass.reactor_sls.node_register pillar="$PILLAR" #-l info
774 #salt-call event.send "reclass/minion/classify" "{$data}"
775 done
776 done
777
778}
779
780## VERIFY
781
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200782
783function verify_salt_master() {
784 set -e
785
786 log_info "Verify Salt master"
787 test -n "$MASTER_HOSTNAME" || exit 1
788
789 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200790 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
791 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200792 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
793 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
794 $SUDO salt-call --no-color grains.items
795 $SUDO salt-call --no-color pillar.data
796 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200797 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec6e40efc2018-03-22 09:47:47 +0100798 if ! $SUDO python -m reclass.cli --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200799 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
800 exit 1
801 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100802 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200803}
804
805function verify_salt_minion() {
806 set -e
807 node=$1
808 log_info "Verifying ${node}"
809 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
810 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
811 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
812 fi
Petr Michalec6e40efc2018-03-22 09:47:47 +0100813 if ! $SUDO python -m reclass.cli --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200814 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
815 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
816 exit 1
817 fi
818 fi
Petr Michalec7edf8322017-11-30 12:01:09 +0100819 set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200820}
821
822function verify_salt_minions() {
823 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200824 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200825 log_info "Verifying minions: $(echo ${NODES}|xargs)"
826
827 # Parallel
828 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
829 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
830
831 function filterFails() {
832 grep -v '/grains' | tee -a $1 | tail -n20
833 }
834
835 log_info "Verify nodes"
836 passed=0
837 for node in ${NODES}; do
838 node=$(basename $node .yml)
839
840 # filter first in cluster.. ctl-01, mon-01, etc..
841 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
842 verify_salt_minion ${node} || continue
843 else
844 echo Skipped $node.
845 fi
846 passed=$(($passed+1))
847 done
848 # fail on failures
849 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
850 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
851 test ! $passed -lt $total || {
852 tail -n50 /tmp/*.pillar_verify
853 return 1
854 }
Petr Michalec7edf8322017-11-30 12:01:09 +0100855 #set +e
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200856}
857
858
859
860##########################################
861# To install salt master/minon
862
863function install() {
864 setup $@
865}
866
867function setup() {
868 # CLI
869 while [ x"$1" != x"" ]; do
870 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
871
872 case $1 in
873 master )
874 install_salt_master_$SALT_SOURCE
875 install_salt_minion_$SALT_SOURCE
876 install_salt_formula_$FORMULAS_SOURCE
877 ;;
878 minion )
879 install_salt_minion_$SALT_SOURCE
880 ;;
881 esac
882 shift
883 done
884 echo DONE
885}
886
887function bootstrap() {
888 log_info "Bootstrap & verification of SaltMaster and configured minions."
889 trap _atexit INT TERM EXIT
890
891 system_config_master
892 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200893 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200894 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200895}
896
897function default() {
898 bootstrap $@
899}
900
901
902##########################################
903[[ "$0" != "$BASH_SOURCE" ]] || {
904# unless file is being sourced
905 default $@
906}